﻿// © 2008 Michele Leroux Bustamante. All rights reserved 
// Book: Learning WCF, O'Reilly
// Book Blog: www.thatindigogirl.com
// Michele's Blog: www.dasblonde.net
// IDesign: www.idesign.net

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Client
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        public Window1()
        {
            InitializeComponent();
        }


       
        private void button2_Click(object sender, RoutedEventArgs e)
        {
            // proxy uses default windows credential unless provided
            Crud.CrudServiceClient crudProxy = new Crud.CrudServiceClient("crudServiceWindows");
            if (!string.IsNullOrEmpty(this.txtUsername.Text) && !string.IsNullOrEmpty(this.txtPassword.Password))
            {
                crudProxy.ClientCredentials.Windows.ClientCredential = new System.Net.NetworkCredential(this.txtUsername.Text, this.txtPassword.Password);
            }

            try
            {
                MessageBox.Show(crudProxy.CreateSomething());
                MessageBox.Show(crudProxy.ReadSomething());
                MessageBox.Show(crudProxy.UpdateSomething());
                MessageBox.Show(crudProxy.DeleteSomething());
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
            finally
            {
                if (crudProxy.State == System.ServiceModel.CommunicationState.Faulted)
                    crudProxy.Abort();
                else
                    crudProxy.Close();
            }

        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            // provide proxy with username/password
            Crud.CrudServiceClient crudProxy = new Crud.CrudServiceClient("crudServiceUserName");
            if (string.IsNullOrEmpty(this.txtUsername.Text) || string.IsNullOrEmpty(this.txtPassword.Password))
                throw new InvalidOperationException("You must supply a username and password.");
            crudProxy.ClientCredentials.UserName.UserName = this.txtUsername.Text;
            crudProxy.ClientCredentials.UserName.Password = this.txtPassword.Password;

            try
            {
                MessageBox.Show(crudProxy.CreateSomething());
                MessageBox.Show(crudProxy.ReadSomething());
                MessageBox.Show(crudProxy.UpdateSomething());
                MessageBox.Show(crudProxy.DeleteSomething());
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
            finally
            {
                if (crudProxy.State == System.ServiceModel.CommunicationState.Faulted)
                    crudProxy.Abort();
                else
                    crudProxy.Close();
            }

        }
    }
}
